## libdecaf 1.0.1

=== CMakeLists.txt ===
############################################################################
# CMakeLists.txt
#
#    Released under the MIT License.  See LICENSE.txt for license information.
#
############################################################################

cmake_minimum_required(VERSION 3.0)
project(DECAF VERSION 1.0 LANGUAGES C CXX)

set(DECAF_SO_VERSION "0")

find_package( PythonInterp 2.7 REQUIRED )

option(ENABLE_SHARED "Build shared library." ON)
option(ENABLE_STATIC "Build static library." ON)
option(ENABLE_STRICT "Build with strict compile options." YES)
option(ENABLE_TESTS  "Enable compilation of tests." OFF)
option(GENERATED_SOURCE_PATH "Where the generated source code is stored, default in the building tree" OFF)

if (GENERATED_SOURCE_PATH)
	set(GSOURCE_PATH ${GENERATED_SOURCE_PATH})
else()
	set(GSOURCE_PATH ${PROJECT_BINARY_DIR}/src/GENERATED)
endif()
message("Generated source code in ${GSOURCE_PATH}")

if(NOT CPACK_GENERATOR AND NOT CMAKE_INSTALL_RPATH AND CMAKE_INSTALL_PREFIX)
	set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
	message(STATUS "Setting install rpath to ${CMAKE_INSTALL_RPATH}")
endif()

include(GNUInstallDirs)
include(CheckSymbolExists)
include(CMakePushCheckState)

include_directories(
	${GSOURCE_PATH}/include/
	src/include/
	src/
	${CMAKE_CURRENT_BINARY_DIR}
)

set(STRICT_OPTIONS_CPP )
set(STRICT_OPTIONS_C )
set(STRICT_OPTIONS_CXX )
if(MSVC)
	if(ENABLE_STRICT)
		set(STRICT_OPTIONS_CPP "${STRICT_OPTIONS_CPP} /WX")
	endif()
else()
	set(STRICT_OPTIONS_CXX "${STRICT_OPTIONS_CXX} -std=c++11 -O2")
	set(STRICT_OPTIONS_CPP "${STRICT_OPTIONS_CPP} -Wall -Wuninitialized -Wno-deprecated-declarations -Wno-missing-field-initializers")
	set(STRICT_OPTIONS_C "${STRICT_OPTIONS_C} -std=c99 -O2 -Wstrict-prototypes -Wno-error=strict-prototypes -fvisibility=hidden")
	if(CMAKE_C_COMPILER_ID MATCHES "Clang")
		set(STRICT_OPTIONS_CPP "${STRICT_OPTIONS_CPP} -Wno-error=unknown-warning-option -Qunused-arguments -Wno-tautological-compare")
		set(STRICT_OPTIONS_CPP "${STRICT_OPTIONS_CPP} -Wno-unused-function -Wno-pass-failed")
	endif()
	if(ENABLE_STRICT)
		set(STRICT_OPTIONS_CPP "${STRICT_OPTIONS_CPP} -Werror -Wextra -Wno-unused-parameter -fno-strict-aliasing")
	endif()
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${STRICT_OPTIONS_C} ${STRICT_OPTIONS_CPP}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${STRICT_OPTIONS_CXX} ${STRICT_OPTIONS_CPP}")

add_subdirectory(src)

if(ENABLE_TESTS)
	enable_testing()
	add_subdirectory(test)
endif()

include(CMakePackageConfigHelpers)
set(ConfigPackageLocation share/decaf/cmake)
export(EXPORT ${EXPORT_TARGETS_NAME}Targets
	FILE "${CMAKE_CURRENT_BINARY_DIR}/DecafTargets.cmake"
)
configure_package_config_file(cmake/DecafConfig.cmake.in
	"${CMAKE_CURRENT_BINARY_DIR}/DecafConfig.cmake"
	INSTALL_DESTINATION ${ConfigPackageLocation}
	NO_SET_AND_CHECK_MACRO
)

install(EXPORT ${EXPORT_TARGETS_NAME}Targets
	FILE DecafTargets.cmake
	DESTINATION ${ConfigPackageLocation}
)
install(FILES
	"${CMAKE_CURRENT_BINARY_DIR}/DecafConfig.cmake"
	DESTINATION ${ConfigPackageLocation}
)

# Doxygen
find_package(Doxygen)
if (DOXYGEN_FOUND)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
	add_custom_target(doc
		${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
		DEPENDS generatedCode
		COMMENT "Generating API documentation with Doxygen" VERBATIM
)
endif()

# CPack settings
set(CPACK_PACKAGE_NAME "decaf")
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}")
set(CPACK_SOURCE_IGnore_FILES
        "^${CMAKE_BINARY_DIR}"
        "/\\\\..+"
)

include(CPack)

=== src/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
#
#    Released under the MIT License.  See LICENSE.txt for license information.
#
############################################################################

if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

set(DECAF_HEADER_FILES
	include/constant_time.h
	include/field.h
	include/keccak_internal.h
	include/portable_endian.h
	include/word.h
)
set(DECAF_SOURCE_FILES_C
	utils.c
	shake.c
	sha512.c
	spongerng.c

)

# default target arch is arch_32 which shall be generic enough to compile mostly on anything
# target arch dirs:
# global one to get the include/arch_intrinsics.h
# availables: arch_32, arch_arm_32, arch_neon, arch_ref64, arch_x86_64
set(TARGET_ARCH_DIR arch_32)
# specific to p25519, to get f_impl.c/h in p25519
#availables: arch_32, arch_ref64, arch_x86_64
set(TARGET_ARCH_DIR_P25519 arch_32)
# specific to p448, to get f_impl.c/h in p448
# availables: arch_32, arch_arm_32, arch_neon, arch_ref64, arch_x86_64
set(TARGET_ARCH_DIR_P448 arch_32)

if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64") # x86_64
	message("Target architecture is x86_64")
	set(TARGET_ARCH_DIR arch_x86_64)
	set(TARGET_ARCH_DIR_P25519 arch_x86_64)
	set(TARGET_ARCH_DIR_P448 arch_x86_64)
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arch64") # shall be arm64 bits, stick to ref64
	message("Target architecture is 64 bits general purpose(arm64 shall use this)")
	set(TARGET_ARCH_DIR arch_ref64)
	set(TARGET_ARCH_DIR_P25519 arch_ref64)
	set(TARGET_ARCH_DIR_P448 arch_ref64)
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm") # is an arm 32 bits
	if (NOT ${CMAKE_ANDROID_ARCH_ABI} STREQUAL "armeabi") # arm <= 5.0 does not support instructions from the lib, keep arch_32
		if(${ANDROID_ARM_NEON})
			message("Target architecture is arm32 NEON")
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfpu=neon") # build with neon flag
			set(TARGET_ARCH_DIR arch_neon)
			set(TARGET_ARCH_DIR_P25519 arch_32) # nothing specific for neon on p25519
			set(TARGET_ARCH_DIR_P448 arch_neon)
		else(${ANDROID_ARM_NEON})
			message("Target architecture is arm32 no NEON")
			set(TARGET_ARCH_DIR arch_arm_32)
			set(TARGET_ARCH_DIR_P25519 arch_32) # nothing specific for arch_arm on p25519
			set(TARGET_ARCH_DIR_P448 arch_arm_32)
		endif(${ANDROID_ARM_NEON})
	endif (NOT ${CMAKE_ANDROID_ARCH_ABI} STREQUAL "armeabi")
else() # nothing picked yet, stick to the
	message("Target architecture is general purpose 32bits")
endif()

include_directories(
	${PROJECT_SOURCE_DIR}/src/include/${TARGET_ARCH_DIR}
)

set(DECAF_SOURCE_FILES_CXX
)

add_subdirectory(curve25519)
add_subdirectory(ed448goldilocks)
add_subdirectory(p25519)
add_subdirectory(p448)

add_subdirectory(generator)

if(ENABLE_STATIC)
	add_library(decaf-static STATIC ${DECAF_HEADER_FILES} ${DECAF_SOURCE_FILES_C} ${DECAF_SOURCE_FILES_CXX} $<TARGET_OBJECTS:p25519> $<TARGET_OBJECTS:p448> $<TARGET_OBJECTS:CURVE25519> $<TARGET_OBJECTS:CURVE448>)
	add_dependencies(decaf-static generatedCode)
	set_target_properties(decaf-static PROPERTIES OUTPUT_NAME decaf)
	target_include_directories(decaf-static INTERFACE $<INSTALL_INTERFACE:include/decaf>)
	target_link_libraries(decaf-static INTERFACE)
endif()
if(ENABLE_SHARED)
	add_library(decaf SHARED ${DECAF_HEADER_FILES} ${DECAF_SOURCE_FILES_C} ${DECAF_SOURCE_FILES_CXX} $<TARGET_OBJECTS:p25519> $<TARGET_OBJECTS:p448> $<TARGET_OBJECTS:CURVE25519> $<TARGET_OBJECTS:CURVE448>)
	add_dependencies(decaf generatedCode)
	set_target_properties(decaf PROPERTIES VERSION ${DECAF_SO_VERSION})
	target_include_directories(decaf INTERFACE $<INSTALL_INTERFACE:include/decaf>)
	target_link_libraries(decaf PRIVATE)
	if(MSVC)
		if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
			install(FILES $<TARGET_PDB_FILE:decaf>
				DESTINATION ${CMAKE_INSTALL_BINDIR}
				PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
			)
		endif()
	endif()
endif()

if(ENABLE_STATIC)
	install(TARGETS decaf-static EXPORT ${EXPORT_TARGETS_NAME}Targets
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()
if(ENABLE_SHARED)
	install(TARGETS decaf EXPORT ${EXPORT_TARGETS_NAME}Targets
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()

install(DIRECTORY ${GSOURCE_PATH}/include/
	DESTINATION include/decaf
	FILES_MATCHING PATTERN "*.h*"
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
)

=== src/generator/curve25519/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
#
#    Released under the MIT License.  See LICENSE.txt for license information.
#
############################################################################
# p25519 field
add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=field --guard=p25519/f_field.h --item=p25519 -o ${GSOURCE_PATH}/c/p25519/f_field.h ${PROJECT_SOURCE_DIR}/src/per_field/f_field.tmpl.h
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_field/f_field.tmpl.h
    OUTPUT ${GSOURCE_PATH}/c/p25519/f_field.h
    COMMENT "Generating code for p25519/f_field.h"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=field --guard=p25519/f_generic.c --item=p25519 -o ${GSOURCE_PATH}/c/p25519/f_generic.c ${PROJECT_SOURCE_DIR}/src/per_field/f_generic.tmpl.c
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_field/f_generic.tmpl.c
    OUTPUT ${GSOURCE_PATH}/c/p25519/f_generic.c
    COMMENT "Generating code for p25519/f_generic.c"
)

add_custom_target(generatorP25519 DEPENDS
	generatorCommonCode
	${GSOURCE_PATH}/c/p25519/f_field.h
	${GSOURCE_PATH}/c/p25519/f_generic.c
	)

# curve25519
add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=curve25519 --guard=curve25519/scalar.c -o ${GSOURCE_PATH}/c/curve25519/scalar.c ${PROJECT_SOURCE_DIR}/src/per_curve/scalar.tmpl.c
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/scalar.tmpl.c
    OUTPUT ${GSOURCE_PATH}/c/curve25519/scalar.c
    COMMENT "Generating code for curve25519/scalar.c"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=curve25519 --guard=curve25519/decaf.c -o ${GSOURCE_PATH}/c/curve25519/decaf.c ${PROJECT_SOURCE_DIR}/src/per_curve/decaf.tmpl.c
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/decaf.tmpl.c
    OUTPUT ${GSOURCE_PATH}/c/curve25519/decaf.c
    COMMENT "Generating code for curve25519/decaf.c"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=curve25519 --guard=curve25519/elligator.c -o ${GSOURCE_PATH}/c/curve25519/elligator.c ${PROJECT_SOURCE_DIR}/src/per_curve/elligator.tmpl.c
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/elligator.tmpl.c
    OUTPUT ${GSOURCE_PATH}/c/curve25519/elligator.c
    COMMENT "Generating code for curve25519/elligator.c"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=curve25519 --guard=curve25519/eddsa.c -o ${GSOURCE_PATH}/c/curve25519/eddsa.c ${PROJECT_SOURCE_DIR}/src/per_curve/eddsa.tmpl.c
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/eddsa.tmpl.c
    OUTPUT ${GSOURCE_PATH}/c/curve25519/eddsa.c
    COMMENT "Generating code for curve25519/eddsa.c"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=curve25519 --guard=curve25519/decaf_gen_tables.c -o ${GSOURCE_PATH}/c/curve25519/decaf_gen_tables.c ${PROJECT_SOURCE_DIR}/src/per_curve/decaf_gen_tables.tmpl.c
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/decaf_gen_tables.tmpl.c
    OUTPUT ${GSOURCE_PATH}/c/curve25519/decaf_gen_tables.c
    COMMENT "Generating code for curve25519/decaf_gen_tables.c"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=curve25519 --guard=decaf/point_255.hxx -o ${GSOURCE_PATH}/include/decaf/point_255.hxx ${PROJECT_SOURCE_DIR}/src/per_curve/point.tmpl.hxx
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/point.tmpl.hxx
    OUTPUT ${GSOURCE_PATH}/include/decaf/point_255.hxx
    COMMENT "Generating code for include/decaf/point_255.hxx"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=curve25519 --guard=decaf/ed255.hxx -o ${GSOURCE_PATH}/include/decaf/ed255.hxx ${PROJECT_SOURCE_DIR}/src/per_curve/eddsa.tmpl.hxx
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/eddsa.tmpl.hxx
    OUTPUT ${GSOURCE_PATH}/include/decaf/ed255.hxx
    COMMENT "Generating code for include/decaf/ed255.hxx"
)

add_custom_target(generatorCurve25519AndGenTablesCommon DEPENDS
			${GSOURCE_PATH}/c/curve25519/decaf.c
			${GSOURCE_PATH}/c/curve25519/scalar.c
			)
add_custom_target(generatorCurve25519 DEPENDS
			generatorP25519
			generatorCurve25519AndGenTablesCommon
       			${GSOURCE_PATH}/c/curve25519/elligator.c
       			${GSOURCE_PATH}/c/curve25519/eddsa.c
			${GSOURCE_PATH}/include/decaf/point_255.hxx
			${GSOURCE_PATH}/include/decaf/ed255.hxx
			)
include_directories(
	${PROJECT_SOURCE_DIR}/src/p25519
	${GSOURCE_PATH}/c/p25519
	${PROJECT_SOURCE_DIR}/src/p25519/${TARGET_ARCH_DIR_P25519}
)

add_executable(decaf_gen_tables_curve25519 EXCLUDE_FROM_ALL ${GSOURCE_PATH}/c/curve25519/decaf_gen_tables.c
			${GSOURCE_PATH}/c/curve25519/decaf.c
			${GSOURCE_PATH}/c/curve25519/scalar.c
			${PROJECT_SOURCE_DIR}/src/utils.c
			$<TARGET_OBJECTS:p25519>)
add_dependencies(decaf_gen_tables_curve25519 generatorCurve25519AndGenTablesCommon)

add_custom_target(decaf_tables_curve25519
	COMMAND decaf_gen_tables_curve25519 > ${PROJECT_SOURCE_DIR}/src/curve25519/decaf_tables.c
	DEPENDS decaf_gen_tables_curve25519
	COMMENT "Generating code for curve25519/decaf_tables.c"
)

=== src/generator/ed448goldilocks/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
#
#    Released under the MIT License.  See LICENSE.txt for license information.
#
############################################################################
# p448 field
add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=field --guard=p448/f_field.h --item=p448 -o ${GSOURCE_PATH}/c/p448/f_field.h ${PROJECT_SOURCE_DIR}/src/per_field/f_field.tmpl.h

    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_field/f_field.tmpl.h
    OUTPUT ${GSOURCE_PATH}/c/p448/f_field.h
    COMMENT "Generating code for p448/f_field.h"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=field --guard=p448/f_generic.c --item=p448 -o ${GSOURCE_PATH}/c/p448/f_generic.c ${PROJECT_SOURCE_DIR}/src/per_field/f_generic.tmpl.c

    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_field/f_generic.tmpl.c
    OUTPUT ${GSOURCE_PATH}/c/p448/f_generic.c
    COMMENT "Generating code for p448/f_generic.c"
)

add_custom_target(generatorP448 DEPENDS
	generatorCommonCode
	${GSOURCE_PATH}/c/p448/f_field.h
	${GSOURCE_PATH}/c/p448/f_generic.c
	)

# ed448goldilocks
add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=ed448goldilocks --guard=ed448goldilocks/scalar.c -o ${GSOURCE_PATH}/c/ed448goldilocks/scalar.c ${PROJECT_SOURCE_DIR}/src/per_curve/scalar.tmpl.c

    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/scalar.tmpl.c
    OUTPUT ${GSOURCE_PATH}/c/ed448goldilocks/scalar.c
    COMMENT "Generating code for ed448goldilocks/scalar.c"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=ed448goldilocks --guard=ed448goldilocks/decaf.c -o ${GSOURCE_PATH}/c/ed448goldilocks/decaf.c ${PROJECT_SOURCE_DIR}/src/per_curve/decaf.tmpl.c

    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/decaf.tmpl.c
    OUTPUT ${GSOURCE_PATH}/c/ed448goldilocks/decaf.c
    COMMENT "Generating code for ed448goldilocks/decaf.c"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=ed448goldilocks --guard=ed448goldilocks/elligator.c -o ${GSOURCE_PATH}/c/ed448goldilocks/elligator.c ${PROJECT_SOURCE_DIR}/src/per_curve/elligator.tmpl.c

    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/elligator.tmpl.c
    OUTPUT ${GSOURCE_PATH}/c/ed448goldilocks/elligator.c
    COMMENT "Generating code for ed448goldilocks/elligator.c"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=ed448goldilocks --guard=ed448goldilocks/eddsa.c -o ${GSOURCE_PATH}/c/ed448goldilocks/eddsa.c ${PROJECT_SOURCE_DIR}/src/per_curve/eddsa.tmpl.c

    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/eddsa.tmpl.c
    OUTPUT ${GSOURCE_PATH}/c/ed448goldilocks/eddsa.c
    COMMENT "Generating code for ed448goldilocks/eddsa.c"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=ed448goldilocks --guard=ed448goldilocks/decaf_gen_tables.c -o ${GSOURCE_PATH}/c/ed448goldilocks/decaf_gen_tables.c ${PROJECT_SOURCE_DIR}/src/per_curve/decaf_gen_tables.tmpl.c

    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/decaf_gen_tables.tmpl.c
    OUTPUT ${GSOURCE_PATH}/c/ed448goldilocks/decaf_gen_tables.c
    COMMENT "Generating code for ed448goldilocks/decaf_gen_tables.c"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=ed448goldilocks --guard=decaf/point_448.hxx -o ${GSOURCE_PATH}/include/decaf/point_448.hxx ${PROJECT_SOURCE_DIR}/src/per_curve/point.tmpl.hxx
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/point.tmpl.hxx
    OUTPUT ${GSOURCE_PATH}/include/decaf/point_448.hxx
    COMMENT "Generating code for include/decaf/point_448.hxx"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=ed448goldilocks --guard=decaf/ed448.hxx -o ${GSOURCE_PATH}/include/decaf/ed448.hxx ${PROJECT_SOURCE_DIR}/src/per_curve/eddsa.tmpl.hxx
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/eddsa.tmpl.hxx
    OUTPUT ${GSOURCE_PATH}/include/decaf/ed448.hxx
    COMMENT "Generating code for include/decaf/ed448.hxx"
)

add_custom_target(generatorEd448AndGenTablesCommon DEPENDS
			${GSOURCE_PATH}/c/ed448goldilocks/scalar.c
			${GSOURCE_PATH}/c/ed448goldilocks/decaf.c
			)
add_custom_target(generatorEd448goldilocks DEPENDS
			generatorP448
			generatorEd448AndGenTablesCommon
       			${GSOURCE_PATH}/c/ed448goldilocks/elligator.c
       			${GSOURCE_PATH}/c/ed448goldilocks/eddsa.c
			${GSOURCE_PATH}/include/decaf/point_448.hxx
			${GSOURCE_PATH}/include/decaf/ed448.hxx
			)
include_directories(
	${PROJECT_SOURCE_DIR}/src/p448
	${GSOURCE_PATH}/c/p448
	${PROJECT_SOURCE_DIR}/src/p448/${TARGET_ARCH_DIR_P448}
)

add_executable(decaf_gen_tables_ed448goldilocks EXCLUDE_FROM_ALL ${GSOURCE_PATH}/c/ed448goldilocks/decaf_gen_tables.c
       			${GSOURCE_PATH}/c/ed448goldilocks/decaf.c
			${GSOURCE_PATH}/c/ed448goldilocks/scalar.c
			${PROJECT_SOURCE_DIR}/src/utils.c
			$<TARGET_OBJECTS:p448>)
add_dependencies(decaf_gen_tables_ed448goldilocks generatorEd448AndGenTablesCommon)

add_custom_target(decaf_tables_ed448goldilocks
	COMMAND decaf_gen_tables_ed448goldilocks > ${PROJECT_SOURCE_DIR}/src/ed448goldilocks/decaf_tables.c
	DEPENDS decaf_gen_tables_ed448goldilocks
	COMMENT "Generating code for ed448goldilocks/decaf_tables.c"
)

=== debian/changelog ===
libdecaf (1.0.1-2) unstable; urgency=medium

  * Source-Only Upload (Closes: #1014832)
  * Add Salsa CI config

 -- Bernhard Schmidt <berni@debian.org>  Sun, 24 Jul 2022 16:44:57 +0200

libdecaf (1.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #893058)

 -- Dennis Filder <d.filder@web.de>  Sat, 09 Apr 2022 15:05:57 +0200

=== debian/control ===
Source: libdecaf
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Bernhard Schmidt <berni@debian.org>,
           Dennis Filder <d.filder@web.de>
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen <!nodoc>,
# a code generator is written in Python 2.7 and thus always
# needed
               python2.7,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Section: libs
Homepage: https://ed448goldilocks.sourceforge.io/
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/libdecaf
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/libdecaf.git

Package: libdecaf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libdecaf0 (= ${binary:Version}), ${misc:Depends}
Description: Ed448-Goldilocks-based elliptic curve cryptography library
 Ed448-Goldilocks is an Edwards-form elliptic curve proposed by
 Michael Hamburg in 2015 and is suitable for fast cryptographic
 operation with small keysizes.
 .
 This package contains files necessary to compile software written
 against libdecaf.

Package: libdecaf0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ed448-Goldilocks-based elliptic curve cryptography library
 Ed448-Goldilocks is an Edwards-form elliptic curve proposed by
 Michael Hamburg in 2015 and is suitable for fast cryptographic
 operation with small keysizes.
 .
 This package contains the runtime shared library.

Package: libdecaf-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ed448-Goldilocks-based elliptic curve cryptography library
 Ed448-Goldilocks is an Edwards-form elliptic curve proposed by
 Michael Hamburg in 2015 and is suitable for fast cryptographic
 operation with small keysizes.
 .
 This package contains the developer documentation.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_build:
	dh_auto_build --buildsystem=cmake
	dh_auto_build --buildsystem=cmake -- doc

## libdecaf 1.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,13 +10,16 @@
 
 set(DECAF_SO_VERSION "0")
 
-find_package( PythonInterp 2.7 REQUIRED )
+find_package(PythonInterp 3 REQUIRED)
 
 option(ENABLE_SHARED "Build shared library." ON)
 option(ENABLE_STATIC "Build static library." ON)
 option(ENABLE_STRICT "Build with strict compile options." YES)
 option(ENABLE_TESTS  "Enable compilation of tests." OFF)
 option(GENERATED_SOURCE_PATH "Where the generated source code is stored, default in the building tree" OFF)
+if (CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
+	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -nostdlib")
+endif()
 
 if (GENERATED_SOURCE_PATH)
 	set(GSOURCE_PATH ${GENERATED_SOURCE_PATH})
@@ -46,12 +49,12 @@
 set(STRICT_OPTIONS_CXX )
 if(MSVC)
 	if(ENABLE_STRICT)
-		set(STRICT_OPTIONS_CPP "${STRICT_OPTIONS_CPP} /WX")
+		set(STRICT_OPTIONS_CPP "${STRICT_OPTIONS_CPP} /WX /Zc:__cplusplus")
 	endif()
 else()
-	set(STRICT_OPTIONS_CXX "${STRICT_OPTIONS_CXX} -std=c++11 -O2")
+	set(STRICT_OPTIONS_CXX "${STRICT_OPTIONS_CXX} -std=c++14 -O2")
 	set(STRICT_OPTIONS_CPP "${STRICT_OPTIONS_CPP} -Wall -Wuninitialized -Wno-deprecated-declarations -Wno-missing-field-initializers")
-	set(STRICT_OPTIONS_C "${STRICT_OPTIONS_C} -std=c99 -O2 -Wstrict-prototypes -Wno-error=strict-prototypes -fvisibility=hidden")
+	set(STRICT_OPTIONS_C "${STRICT_OPTIONS_C} -std=c99 -O2 -Wstrict-prototypes -Wno-error=strict-prototypes -fvisibility=hidden -Wno-error=implicit-function-declaration -Wno-error=attributes")
 	if(CMAKE_C_COMPILER_ID MATCHES "Clang")
 		set(STRICT_OPTIONS_CPP "${STRICT_OPTIONS_CPP} -Wno-error=unknown-warning-option -Qunused-arguments -Wno-tautological-compare")
 		set(STRICT_OPTIONS_CPP "${STRICT_OPTIONS_CPP} -Wno-unused-function -Wno-pass-failed")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -36,12 +36,18 @@
 # availables: arch_32, arch_arm_32, arch_neon, arch_ref64, arch_x86_64
 set(TARGET_ARCH_DIR_P448 arch_32)
 
-if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64") # x86_64
+
+if(MSVC)# On MSVC Windows, Processor is always AMD64 on both platforms (x86/x64)
+	set(MSVC_ARCH ${CMAKE_CXX_COMPILER_ARCHITECTURE_ID})# ${MSVC_ARCH} MATCHES "X64"
+else()
+	set(MSVC_ARCH ${CMAKE_SYSTEM_PROCESSOR})# just to have a value
+endif()
+if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64" AND NOT MSVC)#Decaf doesn't support 64bits on MSVC yet
 	message("Target architecture is x86_64")
 	set(TARGET_ARCH_DIR arch_x86_64)
 	set(TARGET_ARCH_DIR_P25519 arch_x86_64)
 	set(TARGET_ARCH_DIR_P448 arch_x86_64)
-elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arch64") # shall be arm64 bits, stick to ref64
+elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arch64") # shall be arm64 bits, stick to ref64.
 	message("Target architecture is 64 bits general purpose(arm64 shall use this)")
 	set(TARGET_ARCH_DIR arch_ref64)
 	set(TARGET_ARCH_DIR_P25519 arch_ref64)

=== test/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
#
#    Released under the MIT License.  See LICENSE.txt for license information.
#
############################################################################
if(ENABLE_SHARED)
	set(DECAF_LIBRARIES_FOR_TESTER decaf)
else()
	set(DECAF_LIBRARIES_FOR_TESTER decaf-static)
endif()

add_executable(decaf_tester test_decaf.cxx)
set_target_properties(decaf_tester PROPERTIES LINKER_LANGUAGE CXX)
target_link_libraries(decaf_tester ${DECAF_LIBRARIES_FOR_TESTER})

add_executable(ristretto_tester ristretto.cxx)
set_target_properties(ristretto_tester PROPERTIES LINKER_LANGUAGE CXX)
target_link_libraries(ristretto_tester ${DECAF_LIBRARIES_FOR_TESTER})

add_executable(shakesum_tester shakesum.c)
set_target_properties(shakesum_tester PROPERTIES LINKER_LANGUAGE C)
target_link_libraries(shakesum_tester ${DECAF_LIBRARIES_FOR_TESTER})

add_executable(bench bench_decaf.cxx)
set_target_properties(bench PROPERTIES LINKER_LANGUAGE CXX)
target_link_libraries(bench ${DECAF_LIBRARIES_FOR_TESTER})

add_test(NAME decaf COMMAND decaf_tester)
add_test(NAME bench COMMAND bench)

=== src/curve25519/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
#
#    Released under the MIT License.  See LICENSE.txt for license information.
#
############################################################################

include_directories(
	${PROJECT_SOURCE_DIR}/src/p25519
	${GSOURCE_PATH}/c/p25519
	${PROJECT_SOURCE_DIR}/src/p25519/${TARGET_ARCH_DIR_P25519}
)

set(CURVE25519_SOURCE_FILES_C
	${GSOURCE_PATH}/c/curve25519/decaf.c
	${GSOURCE_PATH}/c/curve25519/elligator.c
	${GSOURCE_PATH}/c/curve25519/scalar.c
	${GSOURCE_PATH}/c/curve25519/eddsa.c
	${PROJECT_SOURCE_DIR}/src/curve25519/decaf_tables.c
)

SET_SOURCE_FILES_PROPERTIES(${GSOURCE_PATH}/c/curve25519/decaf.c PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${GSOURCE_PATH}/c/curve25519/elligator.c PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${GSOURCE_PATH}/c/curve25519/scalar.c PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${GSOURCE_PATH}/c/curve25519/eddsa.c PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${PROJECT_SOURCE_DIR}/src/curve25519/decaf_tables.c PROPERTIES GENERATED 1)

add_library(CURVE25519 OBJECT ${CURVE25519_SOURCE_FILES_C})
add_dependencies(CURVE25519 generatedCode p25519)
set_target_properties(CURVE25519 PROPERTIES POSITION_INDEPENDENT_CODE True)

=== src/ed448goldilocks/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
#
#    Released under the MIT License.  See LICENSE.txt for license information.
#
############################################################################

include_directories(
	${PROJECT_SOURCE_DIR}/src/p448
	${GSOURCE_PATH}/c/p448
	${PROJECT_SOURCE_DIR}/src/p448/${TARGET_ARCH_DIR_P448}
)

set(CURVE448_SOURCE_FILES_C
	${GSOURCE_PATH}/c/ed448goldilocks/decaf.c
	${GSOURCE_PATH}/c/ed448goldilocks/elligator.c
	${GSOURCE_PATH}/c/ed448goldilocks/scalar.c
	${GSOURCE_PATH}/c/ed448goldilocks/eddsa.c
	${PROJECT_SOURCE_DIR}/src/ed448goldilocks/decaf_tables.c
)

SET_SOURCE_FILES_PROPERTIES(${GSOURCE_PATH}/c/ed448goldilocks/decaf.c PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${GSOURCE_PATH}/c/ed448goldilocks/elligator.c PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${GSOURCE_PATH}/c/ed448goldilocks/scalar.c PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${GSOURCE_PATH}/c/ed448goldilocks/eddsa.c PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${PROJECT_SOURCE_DIR}/src/ed448goldilocks/decaf_tables.c PROPERTIES GENERATED 1)

add_library(CURVE448 OBJECT ${CURVE448_SOURCE_FILES_C})
add_dependencies(CURVE448 generatedCode p448)
set_target_properties(CURVE448 PROPERTIES POSITION_INDEPENDENT_CODE True)

=== src/generator/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
#
#    Released under the MIT License.  See LICENSE.txt for license information.
#
############################################################################
# global include files
add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=global --guard=decaf.h -o ${GSOURCE_PATH}/include/decaf.h ${PROJECT_SOURCE_DIR}/src/public_include/decaf.tmpl.h
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/public_include/decaf.tmpl.h
    OUTPUT ${GSOURCE_PATH}/include/decaf.h
    COMMENT "Generating code for include/decaf.h"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=global --guard=decaf/eddsa.hxx -o ${GSOURCE_PATH}/include/decaf/eddsa.hxx ${PROJECT_SOURCE_DIR}/src/public_include/decaf/eddsa.tmpl.hxx
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/public_include/decaf/eddsa.tmpl.hxx
    OUTPUT ${GSOURCE_PATH}/include/decaf/eddsa.hxx
    COMMENT "Generating code for include/decaf/eddsa.hxx"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=global --guard=decaf.hxx -o ${GSOURCE_PATH}/include/decaf.hxx ${PROJECT_SOURCE_DIR}/src/public_include/decaf.tmpl.hxx

    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/public_include/decaf.tmpl.hxx
    OUTPUT ${GSOURCE_PATH}/include/decaf.hxx
    COMMENT "Generating code for include/decaf.hxx"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=global --guard=decaf/crypto.hxx -o ${GSOURCE_PATH}/c/decaf/crypto.hxx ${PROJECT_SOURCE_DIR}/src/include/decaf/crypto.tmpl.hxx

    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/include/decaf/crypto.tmpl.hxx
    OUTPUT ${GSOURCE_PATH}/c/decaf/crypto.hxx
    COMMENT "Generating code for decaf/crypto.hxx"
)

# copying
add_custom_command(
    COMMAND ${CMAKE_COMMAND} -E copy
    ${PROJECT_SOURCE_DIR}/src/public_include/decaf/common.h
    ${GSOURCE_PATH}/include/decaf/common.h
    DEPENDS ${PROJECT_SOURCE_DIR}/src/public_include/decaf/common.h
    OUTPUT ${GSOURCE_PATH}/include/decaf/common.h
)

add_custom_command(
    COMMAND ${CMAKE_COMMAND} -E copy
    ${PROJECT_SOURCE_DIR}/src/public_include/decaf/sha512.hxx
    ${GSOURCE_PATH}/include/decaf/sha512.hxx
    DEPENDS ${PROJECT_SOURCE_DIR}/src/public_include/decaf/sha512.hxx
    OUTPUT ${GSOURCE_PATH}/include/decaf/sha512.hxx
)

add_custom_command(
    COMMAND ${CMAKE_COMMAND} -E copy
    ${PROJECT_SOURCE_DIR}/src/public_include/decaf/spongerng.h
    ${GSOURCE_PATH}/include/decaf/spongerng.h
    DEPENDS ${PROJECT_SOURCE_DIR}/src/public_include/decaf/spongerng.h
    OUTPUT ${GSOURCE_PATH}/include/decaf/spongerng.h
)

add_custom_command(
    COMMAND ${CMAKE_COMMAND} -E copy
    ${PROJECT_SOURCE_DIR}/src/public_include/decaf/shake.hxx
    ${GSOURCE_PATH}/include/decaf/shake.hxx
    DEPENDS ${PROJECT_SOURCE_DIR}/src/public_include/decaf/shake.hxx
    OUTPUT ${GSOURCE_PATH}/include/decaf/shake.hxx
)

add_custom_command(
    COMMAND ${CMAKE_COMMAND} -E copy
    ${PROJECT_SOURCE_DIR}/src/public_include/decaf/shake.h
    ${GSOURCE_PATH}/include/decaf/shake.h
    DEPENDS ${PROJECT_SOURCE_DIR}/src/public_include/decaf/shake.h
    OUTPUT ${GSOURCE_PATH}/include/decaf/shake.h
)

add_custom_command(
    COMMAND ${CMAKE_COMMAND} -E copy
    ${PROJECT_SOURCE_DIR}/src/public_include/decaf/spongerng.hxx
    ${GSOURCE_PATH}/include/decaf/spongerng.hxx
    DEPENDS ${PROJECT_SOURCE_DIR}/src/public_include/decaf/spongerng.hxx
    OUTPUT ${GSOURCE_PATH}/include/decaf/spongerng.hxx
)
add_custom_command(
    COMMAND ${CMAKE_COMMAND} -E copy
    ${PROJECT_SOURCE_DIR}/src/public_include/decaf/secure_buffer.hxx
    ${GSOURCE_PATH}/include/decaf/secure_buffer.hxx
    DEPENDS ${PROJECT_SOURCE_DIR}/src/public_include/decaf/secure_buffer.hxx
    OUTPUT ${GSOURCE_PATH}/include/decaf/secure_buffer.hxx
)
add_custom_command(
    COMMAND ${CMAKE_COMMAND} -E copy
    ${PROJECT_SOURCE_DIR}/src/public_include/decaf/sha512.h
    ${GSOURCE_PATH}/include/decaf/sha512.h
    DEPENDS ${PROJECT_SOURCE_DIR}/src/public_include/decaf/sha512.h
    OUTPUT ${GSOURCE_PATH}/include/decaf/sha512.h
)


#these files shall be part of generatorCurve25519 and generatorEd448goldilocks targets but they are both included through decaf.h in a source file
add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=curve25519 --guard=decaf/point_255.h -o ${GSOURCE_PATH}/include/decaf/point_255.h ${PROJECT_SOURCE_DIR}/src/per_curve/point.tmpl.h
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/point.tmpl.h
    OUTPUT ${GSOURCE_PATH}/include/decaf/point_255.h
    COMMENT "Generating code for decaf/point_255.h"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=curve25519 --guard=decaf/ed255.h -o ${GSOURCE_PATH}/include/decaf/ed255.h ${PROJECT_SOURCE_DIR}/src/per_curve/eddsa.tmpl.h
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/eddsa.tmpl.h
    OUTPUT ${GSOURCE_PATH}/include/decaf/ed255.h
    COMMENT "Generating code for decaf/ed255.h"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=ed448goldilocks --guard=decaf/point_448.h -o ${GSOURCE_PATH}/include/decaf/point_448.h ${PROJECT_SOURCE_DIR}/src/per_curve/point.tmpl.h
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/point.tmpl.h
    OUTPUT ${GSOURCE_PATH}/include/decaf/point_448.h
    COMMENT "Generating code for decaf/point_448.h"
)

add_custom_command(
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src/generator/template.py --per=curve --item=ed448goldilocks --guard=decaf/ed448.h -o ${GSOURCE_PATH}/include/decaf/ed448.h ${PROJECT_SOURCE_DIR}/src/per_curve/eddsa.tmpl.h
    DEPENDS ${PROJECT_SOURCE_DIR}/src/generator/template.py ${PROJECT_SOURCE_DIR}/src/per_curve/eddsa.tmpl.h
    OUTPUT ${GSOURCE_PATH}/include/decaf/ed448.h
    COMMENT "Generating code for decaf/ed448.h"
)



add_custom_target(generatorCommonCode DEPENDS
	${GSOURCE_PATH}/include/decaf.h
	${GSOURCE_PATH}/include/decaf/eddsa.hxx
	${GSOURCE_PATH}/include/decaf.hxx
	${GSOURCE_PATH}/c/decaf/crypto.hxx
	${GSOURCE_PATH}/include/decaf/common.h
	${GSOURCE_PATH}/include/decaf/sha512.hxx
	${GSOURCE_PATH}/include/decaf/sha512.h
	${GSOURCE_PATH}/include/decaf/shake.hxx
	${GSOURCE_PATH}/include/decaf/shake.h
	${GSOURCE_PATH}/include/decaf/spongerng.hxx
	${GSOURCE_PATH}/include/decaf/spongerng.h
	${GSOURCE_PATH}/include/decaf/secure_buffer.hxx
	#these files shall be part of curve25519 and ed448goldilocks targets but they are included through decaf.h in common *.c
	${GSOURCE_PATH}/include/decaf/point_255.h
	${GSOURCE_PATH}/include/decaf/point_448.h
	${GSOURCE_PATH}/include/decaf/ed255.h
	${GSOURCE_PATH}/include/decaf/ed448.h
	)

add_subdirectory(curve25519)
add_subdirectory(ed448goldilocks)

add_custom_target(decaf_tables DEPENDS
	decaf_tables_curve25519
	decaf_tables_ed448goldilocks
	)

add_custom_target(generatedCode DEPENDS 
	generatorCommonCode
	generatorEd448goldilocks
	generatorCurve25519
	)

=== src/p25519/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
#
#    Released under the MIT License.  See LICENSE.txt for license information.
#
############################################################################
include_directories(
	${PROJECT_SOURCE_DIR}/src/p25519
	${GSOURCE_PATH}/c/p25519
	${PROJECT_SOURCE_DIR}/src/p25519/${TARGET_ARCH_DIR_P25519}
)

set(P25519_HEADER_FILES
	${GSOURCE_PATH}/c/p25519/f_field.h
	${TARGET_ARCH_DIR_P25519}/f_impl.h
)
set(P25519_SOURCE_FILES_C
	${TARGET_ARCH_DIR_P25519}/f_impl.c
	f_arithmetic.c
	${GSOURCE_PATH}/c/p25519/f_generic.c
)

SET_SOURCE_FILES_PROPERTIES(${GSOURCE_PATH}/c/p25519/f_field.h PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${GSOURCE_PATH}/c/p25519/f_generic.c PROPERTIES GENERATED 1)

add_library(p25519 OBJECT ${P25519_HEADER_FILES} ${P25519_SOURCE_FILES_C})
add_dependencies(p25519 generatorP25519)

set_target_properties(p25519 PROPERTIES POSITION_INDEPENDENT_CODE True)

=== src/p448/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
#
#    Released under the MIT License.  See LICENSE.txt for license information.
#
############################################################################
include_directories(
	${PROJECT_SOURCE_DIR}/src/p448
	${GSOURCE_PATH}/c/p448
	${PROJECT_SOURCE_DIR}/src/p448/${TARGET_ARCH_DIR_P448}
)

set(P448_HEADER_FILES
	${GSOURCE_PATH}/c/p448/f_field.h
	${TARGET_ARCH_DIR_P448}/f_impl.h
)
set(P448_SOURCE_FILES_C
	${TARGET_ARCH_DIR_P448}/f_impl.c
	f_arithmetic.c
	${GSOURCE_PATH}/c/p448/f_generic.c
)

SET_SOURCE_FILES_PROPERTIES(${GSOURCE_PATH}/c/p448/f_field.h PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${GSOURCE_PATH}/c/p448/f_generic.c PROPERTIES GENERATED 1)

add_library(p448 OBJECT ${P448_HEADER_FILES} ${P448_SOURCE_FILES_C})
add_dependencies(p448 generatorP448)

set_target_properties(p448 PROPERTIES POSITION_INDEPENDENT_CODE True)

=== src/generator/curve25519/CMakeLists.txt ===
--- 
+++ 
@@ -75,13 +75,13 @@
     COMMENT "Generating code for include/decaf/ed255.hxx"
 )
 
-add_custom_target(generatorCurve25519AndGenTablesCommon DEPENDS
+add_custom_target(genC25519nTab DEPENDS
 			${GSOURCE_PATH}/c/curve25519/decaf.c
 			${GSOURCE_PATH}/c/curve25519/scalar.c
 			)
 add_custom_target(generatorCurve25519 DEPENDS
 			generatorP25519
-			generatorCurve25519AndGenTablesCommon
+			genC25519nTab
        			${GSOURCE_PATH}/c/curve25519/elligator.c
        			${GSOURCE_PATH}/c/curve25519/eddsa.c
 			${GSOURCE_PATH}/include/decaf/point_255.hxx
@@ -98,7 +98,7 @@
 			${GSOURCE_PATH}/c/curve25519/scalar.c
 			${PROJECT_SOURCE_DIR}/src/utils.c
 			$<TARGET_OBJECTS:p25519>)
-add_dependencies(decaf_gen_tables_curve25519 generatorCurve25519AndGenTablesCommon)
+add_dependencies(decaf_gen_tables_curve25519 genC25519nTab)
 
 add_custom_target(decaf_tables_curve25519
 	COMMAND decaf_gen_tables_curve25519 > ${PROJECT_SOURCE_DIR}/src/curve25519/decaf_tables.c

=== src/generator/ed448goldilocks/CMakeLists.txt ===
--- 
+++ 
@@ -82,13 +82,13 @@
     COMMENT "Generating code for include/decaf/ed448.hxx"
 )
 
-add_custom_target(generatorEd448AndGenTablesCommon DEPENDS
+add_custom_target(genEd448nTab DEPENDS
 			${GSOURCE_PATH}/c/ed448goldilocks/scalar.c
 			${GSOURCE_PATH}/c/ed448goldilocks/decaf.c
 			)
 add_custom_target(generatorEd448goldilocks DEPENDS
 			generatorP448
-			generatorEd448AndGenTablesCommon
+			genEd448nTab
        			${GSOURCE_PATH}/c/ed448goldilocks/elligator.c
        			${GSOURCE_PATH}/c/ed448goldilocks/eddsa.c
 			${GSOURCE_PATH}/include/decaf/point_448.hxx
@@ -105,7 +105,7 @@
 			${GSOURCE_PATH}/c/ed448goldilocks/scalar.c
 			${PROJECT_SOURCE_DIR}/src/utils.c
 			$<TARGET_OBJECTS:p448>)
-add_dependencies(decaf_gen_tables_ed448goldilocks generatorEd448AndGenTablesCommon)
+add_dependencies(decaf_gen_tables_ed448goldilocks genEd448nTab)
 
 add_custom_target(decaf_tables_ed448goldilocks
 	COMMAND decaf_gen_tables_ed448goldilocks > ${PROJECT_SOURCE_DIR}/src/ed448goldilocks/decaf_tables.c

=== debian/changelog ===
libdecaf (1.0.2-3) unstable; urgency=medium

  * Team upload.
  * debian/gbp.conf: use upstream tags
  * rise min required version for cmake (Closes: #1113136)
  * clean all pyc files (Closes: #1045705)

 -- Victor Seva <vseva@debian.org>  Sun, 02 Nov 2025 20:32:08 +0100

libdecaf (1.0.2-2) unstable; urgency=medium

  * Upload to unstable (Closes: #1023238)

 -- Bernhard Schmidt <berni@debian.org>  Thu, 03 Nov 2022 09:31:51 +0100

libdecaf (1.0.2-1) experimental; urgency=medium

  * New upstream release 1.0.2 containing a security fix.
  * Build with Python3 now.
  * Make arch/indep builds work separately and honour nodoc build profile.

 -- Dennis Filder <d.filder@web.de>  Mon, 03 Oct 2022 21:57:20 +0200

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,15 @@
            Dennis Filder <d.filder@web.de>
 Build-Depends: cmake,
                debhelper-compat (= 13),
-               doxygen <!nodoc>,
-# a code generator is written in Python 2.7 and thus always
-# needed
-               python2.7,
+               python3,
+Build-Depends-Indep: doxygen <!nodoc>,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: https://ed448goldilocks.sourceforge.io/
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/libdecaf
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/libdecaf.git
+Description: Ed448-Goldilocks-based elliptic curve cryptography library
 
 Package: libdecaf-dev
 Section: libdevel
@@ -44,7 +43,8 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Build-Profiles: <!nodoc>
+Depends: ${misc:Depends}
 Description: Ed448-Goldilocks-based elliptic curve cryptography library
  Ed448-Goldilocks is an Edwards-form elliptic curve proposed by
  Michael Hamburg in 2015 and is suitable for fast cryptographic

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/pkg-info.mk

DEB_REQUESTED_PACKAGES := $(shell dh_listpackages)
when-in-build-profile     = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 01,1,0$(patsubst $(1),1,$(filter $(1),$(DEB_BUILD_PROFILES))))))
when-not-in-build-profile = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 11,0,1$(patsubst $(1),1,$(filter $(1),$(DEB_BUILD_PROFILES))))))
when-building-package     = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 01,1,0$(patsubst $(1),1,$(filter $(1),$(DEB_REQUESTED_PACKAGES))))))
when-not-building-package = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 11,0,1$(patsubst $(1),1,$(filter $(1),$(DEB_REQUESTED_PACKAGES))))))

%:
	dh $@ --buildsystem=cmake

override_dh_auto_install-indep:
# skip "make install" which is needed (and works) only when building
# -arch targets

execute_before_dh_auto_build-arch:
# hopefully shed some light on why this FTBFS for 32 bit archs on
# reproducible-builds.org, but not on buildd.d.o
ifeq ($(DEB_HOST_ARCH_BITS),32)
	-set
	-cmake --system-information
	-uname -a
	-LD_PRELOAD="" uname -a
endif

override_dh_auto_build-indep:
ifeq (x,$(call when-not-in-build-profile,nodoc,x))
	dh_auto_build --buildsystem=cmake -- doc
endif

=== debian/watch ===
version=4
http://sf.net/ed448goldilocks/ libdecaf-(.*)\.tar\.gz debian uupdate
#https://sourceforge.net/projects/ed448goldilocks/files/
# https://git.code.sf.net/p/ed448goldilocks/code ed448goldilocks-code
